/**
 *   G O M M A - Generic Ontology Mapping Management and Analysis
 * 
 * This code may be freely distributed and modified under the
 * terms of the GNU Lesser General Public License. This should
 * be distributed with the code. If you do not have a copy,
 * see:
 *
 *      http://www.gnu.org/copyleft/lesser.html
 *
 * Copyright for this code is held jointly by the individual
 * authors. These should be listed in @author doc comments.
 *
 * For more information on the GOMMA project and its aims,
 * or to join the project, visit the web pages
 * at:
 *
 *      http://www.izbi.de/
 *
 * and
 *
 *      http://dbs.uni-leipzig.de
 *
 * Interdisciplinary Centre for Bioinformatics, University of Leipzig
 *
 * creation date: 2007/11/10
 * 
 * changes: --
 * 
 **/

package org.gomma.model.mapping;

import it.unimi.dsi.fastutil.ints.IntOpenHashSet;

import java.io.Serializable;
import java.util.Set;

/**
 * The class ObjCorrespondence represents the correspondence between two objects, the so called 
 * domain and range objects. Each correspondence is associated with a semantic type and different 
 * measures, such as support and confidence.
 * @author:  Toralf Kirsten (tkirsten@izbi.uni-leipzig.de)
 * @version: 1.0
 * @since:   JDK1.5
 */
public class ObjCorrespondence extends Object implements Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 5769819758066874400L;

	/**
	 * The domainObjID represents the ID of the domain object of the correspondence. It is usually 
	 * generated by the GOMMA database.
	 */
	private int domainObjID;
	
	/**
	 * The domainObjAccession represents the natural key value of the domain object of the 
	 * correspondence.
	 */
	private String domainObjAccession;
	
	/**
	 * The domainLdsID represents the unique logical source id to which all domain objects belong. 
	 */
	private int domainLdsID;
	
	/**
	 * The domainSourceVersionIdSet contains the unique source version IDs of for all domain 
	 * objects of the correspondence.
	 */
	private Set<Integer> domainSourceVersionIdSet;
	
	/**
	 * The rangeObjID represents the unique id of the range object of the correspondence.
	 */
	private int rangeObjID;

	/**
	 * The rangeObjAccession represents the natural key value of the range object of the 
	 * correspondence.
	 */
	private String rangeObjAccession;
	
	/**
	 * The rangeLdsID represents the unique logical source id to which all range objects belong. 
	 */
	private int rangeLdsID;
	
	/**
	 * The rangeSourceVersionIdSet contains the unique source version IDs of for all range 
	 * objects of the correspondence.
	 */
	private Set<Integer> rangeSourceVersionIdSet;
	
	/**
	 * The support represents the frequency of correspondences between both objects. In general,
	 * the support is 1, in derived mappings but also in mapping compositions the support can be
	 * different, i.e., greater than 1. The concrete meaning strongly depends on the mapping and 
	 * mapping type in which the correspondence occurs.
	 */
	private int support;
	
	/**
	 * The confidence represents the probability that both objects are interrelated. The concrete 
	 * meaning strongly depends on the mapping and mapping type in which the correspondence occurs.
	 */
	private float confidence;
	
	/**
	 * The type represents the type of the correspondence. Concrete values strongly depends on the 
	 * mapping and mapping type in which the correspondence occurs.
	 */
	private String type;
	
	/**
	 * The typeDescr describes the relationship type.
	 * @see type
	 */
	private String typeDescr;
	
	/**
	 * The status represents the status of the correspondence (e.g. "to verify", "handled". 
	 * Concrete values strongly depends on the mapping and mapping type in which the correspondence occurs.
	 */
	private String status;	
	
	/**
	 * The nUserChecked represents the number how many times the correspondence is marked as 
	 * valid by a user. 
	 */
	private int nChecks;
	
	
	
	
	/**
	 * The constructor initializes the class ObjCorrespondence. The correspondence type and 
	 * the number of validations are set to default values. 
	 * @param domain domain object used in the correspondence
	 * @param range range object used in the correspondence
	 * @see org.gomma.model.source.Obj
	 */
	protected ObjCorrespondence(Builder b) {
		this.domainObjID=b.domainObjID;
		this.domainLdsID=b.domainLdsID;
		this.domainObjAccession=b.domainAcc;
		this.domainSourceVersionIdSet=new IntOpenHashSet();
		
		this.rangeObjID=b.rangeObjID;
		this.rangeLdsID=b.rangeLdsID;
		this.rangeObjAccession=b.rangeAcc;
		this.rangeSourceVersionIdSet=new IntOpenHashSet();
		
		this.support=b.support;
		this.confidence=b.confidence;
		this.nChecks=b.nChecks;
		
		this.type = b.typeName;
		this.typeDescr = b.typeDescr;
		
		this.status = b.statusName;
	}
	
	public int getDomainObjID() {
		return this.domainObjID;
	}
	
	public int getDomainLDSID() {
		return this.domainLdsID;
	}
	
	public String getDomainAccessionNumber() {
		return this.domainObjAccession;
	}
	
	public Set<Integer> getDomainSourceVersionIDSet() {
		return this.domainSourceVersionIdSet;
	}

	public int getRangeObjID() {
		return this.rangeObjID;
	}
	
	public int getRangeLDSID() {
		return this.rangeLdsID;
	}
	
	public String getRangeAccessionNumber() {
		return this.rangeObjAccession;
	}
	
	public Set<Integer> getRangeSourceVersionIDSet() {
		return this.rangeSourceVersionIdSet;
	}
	
	public float getConfidence() {
		return this.confidence;
	}
	
	public int getSupport() {
		return this.support;
	}
	
	public int getNumberOfChecks() {
		return this.nChecks;
	}
	
	public String getCorrespondenceTypeName() {
		return this.type;
	}	
	public String getCorrespondenceTypeDescription() {
		return this.typeDescr;
	}
	public String getCorrespondenceStatusName() {
		return this.status;
	}
	public void addDomainSourceVersionID(int id) {
		this.domainSourceVersionIdSet.add(id);
	}
	
	public void addRangeSourceVersionID(int id) {
		this.rangeSourceVersionIdSet.add(id);
	}
	
	public void resetConfidence(float conf) {
		this.confidence = conf;
	}
	
	public void resetSupport(int support) {
		this.support = support;
	}
	
	public void resetType(String type) {
		this.type = type;
		this.typeDescr = type;
	}
	public void resetStatus(String stat) {
		this.status = stat;
	}
	/**
	 * The method compares the current with an external object correspondence. It returns true 
	 * if both correspondences associate the same objects. Otherwise, it returns false.
	 * @param o object correspondence to be compare with
	 * @return true/false
	 */
	public boolean equals(Object o) {
		if (!(o instanceof ObjCorrespondence)) return false;
		return ((ObjCorrespondence)o).domainObjID==this.domainObjID &&
			((ObjCorrespondence)o).rangeObjID==this.rangeObjID;
	}
	
	/**
	 * The method create and returns a new correspondence object inverting the object 
	 * correspondence of the current object. Values, such as support and confidence
	 * are copied.
	 * @return inverted object correspondence
	 */
	public ObjCorrespondence invert() {
				
		String typeName = this.getCorrespondenceTypeName();		
		if(typeName.equals("is_less_general_than")){
			typeName = "is_more_general_than";
		}else if(typeName.equals("is_more_general_than")){
			typeName = "is_less_general_than";
		}
		
		ObjCorrespondence corr = new ObjCorrespondence.Builder(
				this.getRangeObjID(),this.getRangeLDSID(),this.getDomainObjID(),this.getDomainLDSID())
					.domainAccessionNumber(this.getRangeAccessionNumber())
					.rangeAccessionNumber(this.getDomainAccessionNumber())
					.confidence(this.getConfidence())
					.support(this.getSupport())
					.numberOfUserChecks(this.getNumberOfChecks())
					.typeName(typeName)
					.typeDescription(this.getCorrespondenceTypeDescription())
					.statusName(this.getCorrespondenceStatusName())
					.build();
		
		for (int srcID : this.getDomainSourceVersionIDSet()) corr.addRangeSourceVersionID(srcID);
		for (int srcID : this.getRangeSourceVersionIDSet()) corr.addDomainSourceVersionID(srcID);
		
		return corr;
	}
	
	/**
	 * @see Object#toString()
	 */
	public String toString() {
		return this.domainObjAccession+" ("+this.domainObjID+") - "+this.rangeObjAccession+" ("+this.rangeObjID+")";
	}
	
	public static class Builder implements Serializable {
		
		
		/**
		 * 
		 */
		private static final long serialVersionUID = 2040559620122887937L;
		
		private final int domainObjID;
		private final int domainLdsID;
		private final int rangeObjID;
		private final int rangeLdsID;
		
		private String domainAcc = "N/A";
		private String rangeAcc  = "N/A";
		
		private float confidence = 0F;
		private int support = 0;
		private int nChecks = 0;
		
		private String typeName =  "N/A";
		private String typeDescr = "N/A";
		private String statusName =  "N/A";
		
		public Builder(int domainID, int domainLDS, int rangeID, int rangeLDS) {
			this.domainObjID = domainID;
			this.domainLdsID = domainLDS;
			this.rangeObjID = rangeID;
			this.rangeLdsID = rangeLDS;
		}
		
		public Builder domainAccessionNumber(String acc) {
			this.domainAcc = acc;
			return this;
		}
		
		public Builder rangeAccessionNumber(String acc) {
			this.rangeAcc = acc;
			return this;
		}
		
		public Builder typeName(String name) {
			this.typeName = name;
			return this;
		}
		
		public Builder typeDescription(String descr) {
			this.typeDescr = descr;
			return this;
		}
		public Builder statusName(String sname) {
			this.statusName = sname;
			return this;
		}
		public Builder confidence(float conf) {
			this.confidence = conf;
			return this;
		}
		
		public Builder support(int sup) {
			this.support = sup;
			return this;
		}
		
		public Builder numberOfUserChecks(int n) {
			this.nChecks = n;
			return this;
		}
		
		public ObjCorrespondence build() {
			return new ObjCorrespondence(this);
		}
	}
}
